#!/usr/bin/env bash

#define CONFIG_PATH_REL                     "/config/"
#define SCRIPT_PATH_REL                     "/script/fota/"
#define TMP_PATH                            "/var/tmp/iiot_aliyun/linkedge/fota"
#define EXTRACT_PATH                        TMP_PATH "/gateway"
#define EXTRACT_PACKAGED_DIR                "upgrade"

#define ota_filename_main                   "alinkota"
#define otafile_full_path                   TMP_PATH "/" ota_filename_main ".bin"

BACKUP_SUFFIX=.backup
DELETE_SUFFIX=.delete

UPGRADING_TOUCH_DIR_NAME=_ota_upgrading_tagfiles
UPGRADING_STEP_FILENAME_INIT=step_
UPGRADING_BACKUP_BEGAN=backup_began
UPGRADING_BACKUP_FAILED=backup_failed
UPGRADING_ROLLBACK=rollback
UPGRADING_ROLLBACK_DONE=rollback_done

UPGRADING_DIR_PATH=${PROJECT_ROOT}/${OTA_UPGRADING_TAGFILES}

PROJECT_ROOT=$(dirname "$0") 

function is_upgrading_tagfile_touched () 
{
    [ -e ${UPGRADING_DIR_PATH} ]
}

function is_upgrading_backup_began_touched() 
{
    [ -e ${UPGRADING_DIR_PATH}/backup_began ] 
}

function is_upgrading_backup_failed_touched() 
{
    [ -e ${UPGRADING_DIR_PATH}/backup_failed ] 
}

function is_upgrading_rollback_touched() 
{
    [ -e ${UPGRADING_DIR_PATH}/rollback ] 
}

function is_upgrading_rollback_done_touched() 
{
    [ -e ${UPGRADING_DIR_PATH}/rollback_done ] 
}

function is_upgrading_step_file_exists()
{
    [ -e ${UPGRADING_DIR_PATH}/step_${1} ]
}

function upgrade_failed_rollback() 
{
    :
}

function exec_upgrade_backup_failed_recover()
{
}
function remove_upgrading_backup_begin()
{
    :
}
function remove_upgrading_rollback_done()
{
    :
}
function remove_upgrading_backup_failed()
{
    :
}
function exec_upgrade_failed_rollback()
{
    :
}
function remove_upgrading_tagfiles()
{
    :
}
function remove_upgrading_step_file()
{
    :
}
function check_fail_startup()
{
    if is_upgrading_tagfile_touched
    then
        if is_upgrading_backup_failed_touched || is_upgrading_backup_failed_touched 
        then
            exec_upgrade_backup_failed_recover
            if is_upgrading_backup_began_touched
            then
                remove_upgrading_backup_begin
            fi
            if is_upgrading_backup_failed_touched
            then
                remove_upgrading_backup_failed
            fi
        elif is_upgrading_rollback_touched
        then
            exec_upgrade_failed_rollback
        elif is_upgrading_rollback_done_touched
        then
            remove_upgrading_rollback_done
            remove_upgrading_tagfiles
        elif [ is_upgrading_step_file_exists 0 ] \
            || [ is_upgrading_step_file_exists 1 ] \
            || [ is_upgrading_step_file_exists 2 ] \
            || [ is_upgrading_step_file_exists 3 ] 
        then
            exec_upgrade_failed_rollback
            for i in 0 1 2 3
            do
                if is_upgrading_step_file_exists ${i}
                then 
                    remove_upgrading_step_file ${i}
                fi
            done
        elif is_upgrading_step_file_exists 4
        then
            :
        else
            : # unknown error
        fi
    fi
}

check_fail_startup
# start shell script
